from Acquisition import Implicit
from Globals import Persistent
from AccessControl.Role import RoleManager
from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from Globals import DTMLFile
import re
import urllib
import traceback, sys, os 
from OFS.SimpleItem import Item

addForm = DTMLFile('dtml/addForm',globals())

def manage_addKebasData(self, id, url, regex_pattern, start_kebas='', end_kebas='', render_method='', REQUEST=None):
	"""the add method"""
	ob = KebasData(id, url, regex_pattern, start_kebas, end_kebas)
	self._setObject(id,ob)
	if REQUEST is not None:
		return REQUEST.RESPONSE.redirect('manage_workspace') 

class KebasData(Implicit, Persistent, RoleManager, Item):
	"""my first attempt to a python product."""

	meta_type = 'Kebas Data'

	manage_options=(
              {'label' : 'Edit', 'action' : 'editKebasDataForm', 'help': ('KebasData','edit.txt')},
              {'label' : 'View', 'action' : '', 'help': ('KebasData','index.txt')},
              ) + RoleManager.manage_options + Item.manage_options

	security=ClassSecurityInfo()
	security.declareProtected('View', 'index_html')
	#index_html = DTMLFile('dtml/index_html',globals())
	main= DTMLFile('dtml/index_html',globals())
	security.declareProtected('Custom View', 'custom_view')
	c_view = DTMLFile('dtml/custom_view',globals())
	security.declareProtected('View management screens','editKebasDataForm')
	editKebasDataForm = DTMLFile('dtml/editKebasDataForm',globals())


	def __init__(self, id, url, regex_pattern, start_kebas='', end_kebas='', render_method=''):
		"""my init"""
		self.id = id
		self.url = url
		self.regex_pattern = regex_pattern
		self.start_kebas = start_kebas
		self.end_kebas = end_kebas
		self.match=[]
		self.render_method = render_method
		#self.f = self._get_url()
	#	print type(self.url), type(self.regex)

	def _get_url(self,url, REQUEST=None):
		"""get the url"""
		#print self.url
		self.url = url
		self.start_kebas_re = re.compile(self.start_kebas, re.I|re.S|re.DOTALL)
		self.end_kebas_re = re.compile(self.end_kebas, re.I|re.S|re.DOTALL)
		try:
			self.f = urllib.urlopen(self.url).read()
		except:
			raise """try initialize again"""

		if self.start_kebas == '' and self.end_kebas == '':
			self.f = self.f
		else:
			x = self.start_kebas_re.search(self.f)
			y = self.end_kebas_re.search(self.f)
			try:
				self.f = self.f[x.end():y.start()]
			except:
				tb = traceback.extract_tb(sys.exc_info()[2])
                		tb.reverse()
                		self._v_errors = ["failed",
                                  "%s: %s" % sys.exc_info()[:2],
                                  ] + map(str, tb)
		return self.f

		if REQUEST is not None:
			return self.editKebasDataForm(REQUEST,
                      management_view='Edit',
                      manage_tabs_message='Kebas Data attributes changed.')
	
	security.declareProtected('View management screens','get_matched')
	def get_matched(self, url=None, REQUEST=None):
		"""get the matched pattern"""
		if url is not None:
			self.url = url
			self.f = self._get_url(url=self.url)
		else:
			self.f = self._get_url(url=self.url)
		self.regex = re.compile(self.regex_pattern,re.I|re.S)
		self.match= self.regex.findall(self.f)
		self._p_changed = 1
		#return self.match
		if REQUEST is not None:
			return self.editKebasDataForm(REQUEST,
                      management_view='Edit',
                      manage_tabs_message='Kebas Data initialized.')
		else:
			return self.index_html(REQUEST)
	

	#security.declareProtected('View','custom_view')
	def index_html(self,REQUEST=None):
		"""Custom view.  calls dtml method defined in render_method.  this is currently a hack,
		until i get the equivalent to what i'm doing here.
		What i'm doing here is - set up a file called custom_view.dtml, and has 
		<dtml-var "_[render_method]">.  any elegant way of acieving this in python?
		"""
		#self.match = self.get_matched()
		if self.render_method != '':
			return self.c_view(self.render_method)
		else:
			return self.main(REQUEST)
		#return apply(getattr(self,self.render_method),REQUEST)

	security.declareProtected('Change Kebas Data','manage_editKebasData')
	def manage_editKebasData(self, url, regex_pattern, start_kebas='', end_kebas='', render_method='', REQUEST=None):
		"""change method"""
		self.url = url
                self.regex_pattern = regex_pattern
		self.start_kebas = start_kebas
		self.end_kebas = end_kebas
                self.match=[]
		self.render_method = render_method
		if REQUEST is not None:
			return self.editKebasDataForm(REQUEST,
				management_view='Edit',
				manage_tabs_message = 'Attributes changed')

InitializeClass(KebasData)
